Rice.require 'Native'
Rice.require 'commandString'

-----------------------------------------------------------------------------
-- Local Function :
-----------------------------------------------------------------------------
local function isEmpty( value )
	return ( not value or '' == value )
end

local function GetCommandCharcode( tbl )
	if( 'on' == tbl.gb18030support	and
		'8' == tbl.jh_charset			) then
		return 'utf8'
	elseif ('10' == tbl.jh_charset or '11' == tbl.jh_charset or '33' == tbl.jh_charset) and ('on' == tbl.output_utf8_rtl_language) then
		return 'utf8'
	else
		return 'osdependent'
	end
end

local function GetJob_Name( tbl )
	if( isEmpty(tbl.jobname) ) then
		return '""'
	else
		return '"' .. get_trimmed_command_string( tbl.jobname, GetCommandCharcode( tbl ), 80 ) .. '"'
	end
end

local function generate_paper_counter( tbl )
	local command_tbl = {}

	if( nil ~= tbl.endjob_counterinfo_max ) then
		for index = 1, tbl.endjob_counterinfo_max do
			if( nil ~= tbl[ 'endjob_counterinfo' .. index ] ) then
				table.insert( command_tbl, string.format( '@PJL SET JOBADDITIONALINFO = "%s"\r\n', tbl[ 'endjob_counterinfo' .. index ] ) )
			else
				break
			end
		end
		return table.concat( command_tbl )
	else
		return nil
	end
end

-----------------------------------------------------------------------------
-- Export Function : Generate Command
-----------------------------------------------------------------------------
function generate_command(settings_table)
  local commands = {}

  table.insert( commands, string.char(0x1b) .. '%-12345X')

  table.insert( commands, generate_paper_counter( settings_table ) )

  table.insert( commands, '@PJL EOJ NAME = ' .. GetJob_Name( settings_table ) .. '\r\n' )

  table.insert( commands, string.char(0x1b) .. '%-12345X')

  return table.concat(commands)
end

return true
