Rice.require 'Native'
Rice.require 'Rice.CapsDB'
Rice.require 'Rice.PrintTicket'
Rice.require 'Rice.PaperDB'
Rice.require 'Rice.Devmode'
Rice.require 'TableConverter'
Rice.require 'printticket_core'
Rice.require 'devmode_to_printticket_table'

function convert_all_pt_tables( item_table , option_info, headerfootersupport_value, enable_outputcompresseddataexceptpjl_value )
	local result_all_tables = {}
	local count = 1

	for k in pairs( dev2pt_table ) do
		if( nil ~= item_table[k] ) then
			if( ( 'phf_print' ~= k and 'outputcompresseddataexceptpjl' ~= k )									or
				( 'phf_print' == k and 'on' == headerfootersupport_value )										or
				( 'outputcompresseddataexceptpjl' == k and 'on' == enable_outputcompresseddataexceptpjl_value ) ) then
				local tbl = convert_ptpc_table( item_table, dev2pt_table[k] ,option_info)
				if( nil ~= tbl ) then
					result_all_tables[count] = tbl
					count = count + 1
				end
			end
		end
	end

	return result_all_tables
end


function act_devmode_to_printticket( architecture_type )
	local result = 'false'
	local cdb = Rice.CapsDB
	local pt = Rice.PrintTicket
	local paper_db = Rice.PaperDB

	if pt and cdb and paper_db then
		local option_info = create_option_info(cdb, paper_db)

		set_namespace(pt)

		if( "monolithic" == architecture_type ) then
			pt.set_element(	"/",
							"psf:PrintTicket",
							xmlns_table.psf )
			set_root_attribute(pt,printticket_xpath)
		end

		local all_item_tbl = get_all_items(cdb)

		local collate_val = '0'
		local devmode = Rice.Devmode
		if devmode then
			collate_val = devmode.get('dmCollate')
		end
		all_item_tbl['dmCollate'] = collate_val
		
		local headerfootersupport_value = cdb.get('headerfootersupport')
		local enable_outputcompresseddataexceptpjl_value = cdb.get('enable_outputcompresseddataexceptpjl')
		local converted_all_pt_tables = convert_all_pt_tables(all_item_tbl, option_info, headerfootersupport_value, enable_outputcompresseddataexceptpjl_value)
		generate_printtickets(pt,converted_all_pt_tables)
		result = 'true'
	end

	return result
end
