Rice.require 'Native'
Rice.require 'Rice.CapsDB'
Rice.require 'Rice.PaperDB'
Rice.require 'Rice.PrintCapabilities'
Rice.require 'TableConverter'
Rice.require 'printticket_core'
Rice.require 'get_printcapabilities_table'

--CDB񂩂̕ϊ--
function convert_all_pc_tables( item_table, option_info, headerfootersupport_value, enable_outputcompresseddataexceptpjl_value )
	local result_all_tables = {}

	local function isMember( value )
		local hf_table = { 'phf_print', 'phf_font', 'phf_fontsize', 'phf_text_userdefined' }
		for i = 1 , #hf_table do
			if(hf_table[i] == value) then
				return true
			end
		end
		return false
	end

	for k, v in pairs( pc_table ) do
		if( item_table[k] )then
			if( ( ( not isMember( k ) ) and 'outputcompresseddataexceptpjl' ~= k )								or
				( isMember( k ) and 'on' == headerfootersupport_value )											or
				( 'outputcompresseddataexceptpjl' == k and 'on' == enable_outputcompresseddataexceptpjl_value ) ) then
				local tbl = convert_ptpc_table( item_table, v, option_info)
				if( tbl ) then
					result_all_tables[ #result_all_tables + 1 ] = tbl
				end
			end
		end
	end

	return result_all_tables
end

--PC:ACeڍ׎擾 --
function get_all_items_detail( cdb )
	local item_list = nil
	local item_table = {}

	if( nil == cdb ) then
		return item_table
	end

	item_list = cdb.features()

	if( nil ~= item_list ) then
		for i, v in ipairs(item_list) do
			item = cdb.get_detail(v)
			if(nil ~= item) then
				--Stringp --
				if('string' == item['type']) then
					item_table[v] =
							{
								max = tostring(item['max']),
								min = tostring(item['min']),
								default = item['default'],
								current = item['current']
							}
				--Rangep --
				elseif('range' == item['type']) then
					item_table[v] =
							{
								max = tostring(item['max']),
								min = tostring(item['min']),
								default = item['default'],
								current = item['current']
							}
				--PickOnep --
				elseif('pickone' == item['type']) then
					local options = {}
					index = 1

					if(nil ~= item['elements']) then
						for item_name, item_value in pairs(item['elements']) do
							if(item['current'] == item_name)then
								options['current'] = 
								{
									name = item_name,
									condition = item_value
								
								}
							elseif(item['default'] == item_name)then
								options['default'] = 
								{
									name = item_name,
									condition = item_value
								
								}
							else
								table.insert(options, 
									{
										name = item_name,
										condition = item_value
									}
								)
							end
						end
						item_table[v] = options
					end

				--̑̏ꍇ͌ݒl擾 --
				else
					item_table[v] = 
							{
								default = item['default'],
								current = item['current']
							}
				end
			end
		end
	end
	return item_table
end

--GetPrintCapabilitiesC--
function act_get_print_capabilities( architecture_type )

		local result = false
		local cdb = Rice.CapsDB
		local pc = Rice.PrintCapabilities

		--PC--
		set_namespace(pc)
		pc.set_processiong_instruction()

		--mhCôPC쐬--
		if( "monolithic" == architecture_type ) then
			pc.set_element(	"/",
							"psf:PrintCapabilities",
							xmlns_table.psf )
				set_root_attribute(pc,printcapabilities_xpath)
		end

		-- PrintTicket擾łꍇ́ACDBɂ𔽉f
		if Rice.PrintTicket then
			act_printticket_to_devmode( architecture_type )
		end

		--CDB擾--
		local all_item_tbl = get_all_items_detail(cdb)
		
		local paper_db = Rice.PaperDB
		local option_info = create_option_info(cdb, paper_db)
		
		--擾CDBPC쐬--
		local headerfootersupport_value = cdb.get('headerfootersupport')
		local enable_outputcompresseddataexceptpjl_value = cdb.get('enable_outputcompresseddataexceptpjl')
		local converted_all_pc_tables = convert_all_pc_tables(all_item_tbl, option_info, headerfootersupport_value, enable_outputcompresseddataexceptpjl_value)
		generate_printcapabilities(pc, converted_all_pc_tables)

		return 'true'

end
