Rice.require 'Rice.CapsDB'
Rice.require 'Rice.PrintTicket'
Rice.require 'printticket_core'
Rice.require 'devmode_to_printticket'
Rice.require 'printticket_to_devmode'
Rice.require 'printticket_to_devmode_table'

function act_validate_printticket( architecture_type )
	local result = 'false'
	local cdb = Rice.CapsDB
	local pt = Rice.PrintTicket

	if pt and cdb and architecture_type and set_namespace(pt) then
		-- get items from default devmode
		local pre_all_item_tbl = get_all_items(cdb)

		-- get items from print ticket
		local converted_xpath_table 	= generate_all_target_xpath(pt)
		local extracted_values 			= extract_value(pt,converted_xpath_table)
		local item_table_from_pt 		= convert_item_values(extracted_values)

		-- overwrite pre_all_item_tbl using item_table_from_pt
		for i in pairs(pre_all_item_tbl) do
			for j in pairs(item_table_from_pt) do
				if(i == j) then
					pre_all_item_tbl[i]=item_table_from_pt[j]
				end
			end
		end

		act_printticket_to_devmode(architecture_type)

		-- clear print ticket
		pt.delete_node('/'..solve_local_prefix(pt, 'psf:PrintTicket'))

		act_devmode_to_printticket(architecture_type)

		-- get items from validated devmode
		local post_all_item_tbl = get_all_items(cdb)

		-- compare pre_all_item_tbl with post_all_item_tbl
		local is_same_table = true
		for i in pairs(pre_all_item_tbl) do
			local is_same_key_value = false
			for j in pairs(post_all_item_tbl) do
				if(i == j) then
					if(pre_all_item_tbl[i]==post_all_item_tbl[j]) then
						is_same_key_value = true
					end
				end
			end
			if(false == is_same_key_value) then
				is_same_table = false
				break
			end
		end

		if(true == is_same_table) then
			result = 'no_conflict'
		else
			result = 'conflict_resolved'
		end
	end

	return result
end
