Rice.require 'Native'
Rice.require 'Bit'
Rice.require 'UTF8'
Rice.require 'Rice.CapsDB'
Rice.require 'Rice.LangDB'
Rice.require 'FileDialog'

local cp_acp = 0

local function ansi_str(utf8_str)
  return utf8_str and UTF8.decode(utf8_str, cp_acp) or ''
end

local file_path = ansi_str(Rice.CapsDB.get('pow_filepath'))
local showing = ansi_str(Rice.LangDB.get('pow_dialog_filetypename_ppo'))
local file_name
local directory_name = 5

if(file_path) then
  local directory_name_end, file_name_end = file_path:find('\\[^\\]+$')
  if(directory_name_end and file_name_end) then
    file_name = file_path:sub(directory_name_end + 1, file_name_end)
    directory_name = file_path:sub(1, directory_name_end)
  end
end

file_path = FileDialog.open(
  'ppo',
  showing,
  Bit.OR(
    FileDialog.OFN_PATHMUSTEXIST,
    FileDialog.OFN_HIDEREADONLY,
    FileDialog.OFN_NONETWORKBUTTON,
    FileDialog.OFN_FILEMUSTEXIST
  ),
  directory_name,
  file_name
)

if( nil ~= file_path ) then
   Rice.CapsDB.set('pow_filepath', UTF8.encode(file_path, cp_acp))
end

return true
